// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    BerechtigungResponseDTO,
    ModifyUserFachadminRequestDTO,
    UpdateRvPermissionsDTO,
    UserFachadminResponseDTO,
} from '../models';

export interface FetchRegelungsvorhabenPermissionsRequest {
    regelungsvorhabenId: string;
}

export interface UpdateFachadministratorsRequest {
    modifyUserFachadminRequestDTO: ModifyUserFachadminRequestDTO;
}

export interface UpdateRegelungsvorhabenPermissionsRequest {
    regelungsvorhabenId: string;
    updateRvPermissionsDTO: UpdateRvPermissionsDTO;
}

/**
 * no description
 */
export class FachadministratorControllerApi extends BaseAPI {

    /**
     * Lädt die Liste aller Federführer eines Regelungsvorhaben
     * FETCH LIST OF FEDERFUEHRER
     */
    fetchRegelungsvorhabenPermissions({ regelungsvorhabenId }: FetchRegelungsvorhabenPermissionsRequest): Observable<Array<BerechtigungResponseDTO>>
    fetchRegelungsvorhabenPermissions({ regelungsvorhabenId }: FetchRegelungsvorhabenPermissionsRequest, opts?: OperationOpts): Observable<AjaxResponse<Array<BerechtigungResponseDTO>>>
    fetchRegelungsvorhabenPermissions({ regelungsvorhabenId }: FetchRegelungsvorhabenPermissionsRequest, opts?: OperationOpts): Observable<Array<BerechtigungResponseDTO> | AjaxResponse<Array<BerechtigungResponseDTO>>> {
        throwIfNullOrUndefined(regelungsvorhabenId, 'regelungsvorhabenId', 'fetchRegelungsvorhabenPermissions');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<BerechtigungResponseDTO>>({
            url: '/fachadministrator/regelungsvorhaben/{regelungsvorhabenId}'.replace('{regelungsvorhabenId}', encodeURI(regelungsvorhabenId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die Liste der Fachadminstratoren des eigenen Ressorts
     * GET LIST OF FACH-ADMINS
     */
    getListOfFachadminsistrators(): Observable<UserFachadminResponseDTO>
    getListOfFachadminsistrators(opts?: OperationOpts): Observable<AjaxResponse<UserFachadminResponseDTO>>
    getListOfFachadminsistrators(opts?: OperationOpts): Observable<UserFachadminResponseDTO | AjaxResponse<UserFachadminResponseDTO>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<UserFachadminResponseDTO>({
            url: '/fachadministrator',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Modifiziert die Liste der Fachadminstratoren des eigenen Ressorts
     * MODIFY LIST OF FACH-ADMINS
     */
    updateFachadministrators({ modifyUserFachadminRequestDTO }: UpdateFachadministratorsRequest): Observable<void>
    updateFachadministrators({ modifyUserFachadminRequestDTO }: UpdateFachadministratorsRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    updateFachadministrators({ modifyUserFachadminRequestDTO }: UpdateFachadministratorsRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(modifyUserFachadminRequestDTO, 'modifyUserFachadminRequestDTO', 'updateFachadministrators');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/fachadministrator',
            method: 'PUT',
            headers,
            body: modifyUserFachadminRequestDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ändert für ein Regelungsvorhaben die Federführer
     * MODIFY PERMISSION OF RV
     */
    updateRegelungsvorhabenPermissions({ regelungsvorhabenId, updateRvPermissionsDTO }: UpdateRegelungsvorhabenPermissionsRequest): Observable<void>
    updateRegelungsvorhabenPermissions({ regelungsvorhabenId, updateRvPermissionsDTO }: UpdateRegelungsvorhabenPermissionsRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    updateRegelungsvorhabenPermissions({ regelungsvorhabenId, updateRvPermissionsDTO }: UpdateRegelungsvorhabenPermissionsRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(regelungsvorhabenId, 'regelungsvorhabenId', 'updateRegelungsvorhabenPermissions');
        throwIfNullOrUndefined(updateRvPermissionsDTO, 'updateRvPermissionsDTO', 'updateRegelungsvorhabenPermissions');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/fachadministrator/regelungsvorhaben/{regelungsvorhabenId}'.replace('{regelungsvorhabenId}', encodeURI(regelungsvorhabenId)),
            method: 'PUT',
            headers,
            body: updateRvPermissionsDTO,
        }, opts?.responseOpts);
    };

}
